;IN6 - LIGHT SENSOR 
;IN7 - SOIL MOISTURE
;IN5- TEMP SENSOR
RS   BIT  P2.5   		 ; P2.5 is connected to RS pin of LCD 
RW   BIT  P2.4  		 ; P2.6 is connected to R/W pin of LCD 
E   BIT  P2.7   		 ; P2.5 is connected to E pin of LCD 
 
LCDDATA  EQU  P0  	; P0.0-P0.7 are connected to LCD data pins D0-D7 

LIGHT_LEVEL   EQU  35h    ;Buffer to store light level
MOIST_LEVEL   EQU  32h

PUMP   EQU  P2.3 
heater EQU P2.2 
LIGHT EQU P2.1


 
OE  EQU  P3.2    		; Pin 9 Output Enable 
START EQU  P3.6    		; Pin 6 Start 
EOC  EQU  P3.3    		; Pin 7 EOC 
ADD_A EQU  P3.4    		; Pin 25 ADD A 
ADD_B EQU  P3.5    		; Pin 24 ADD B 
ALE  EQU  P3.7    		; Pin 22 ALE 
 
ADCDATA  EQU  P1    		; Data Lines 
 

L_BUFFER  EQU  33h    ;Light buffer (ADC o/p) 
M_BUFFER  EQU  30h
T_BUFFER  EQU  31h    ;Temperature buffer (ADC o/p)

 
org 00h 
  
CLR LIGHT
CLR PUMP
clr heater
mov sp,#40h
main: 
 
;Main Code 
  
MOV TMOD, #21h 		;Timer 0 Mode 1, 16 bit timer (for generating 5 
			;second delay for LCD) 
			;timer 1 mode 2,8 bit auto reload for serial

mov TH1,#-3

mov SCON,#50h

setb tr1

 ;LCD initialisation 
MOV A, #38H    	 ;init. LCD 2 lines,5x7 matrix (CHANGE THIS!!!) 
ACALL comnwrt       	;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #0EH        ;display on, cursor on 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #01        ;clear LCD 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #06H       ;shift cursor right 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 


lcd1:   			 ;Displaying initialisation message 
MOV A, #080H      	 ;cursor at line 1, position 0 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV DPTR, #init1    ;address of line 1 of initialisation message 
repeat1: 
CLR A 
MOVC A, @A+DPTR    ;moving the data to accumulator 
JZ line_2 
ACALL datawrt    ;call data display routine 
ACALL lcddelay    ;give LCD some time 
INC DPTR      ;increment address 
SJMP repeat1 
 
line_2: 
MOV A, #0C0h       ;cursor at line 2, position 0 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV DPTR, #init2    ;address of line 2 of initialisation message 
repeat2: 
CLR A 
MOVC A, @A+DPTR    ;moving the data to accumulator 
JZ back 
LCALL datawrt    ;call data display routine 
LCALL lcddelay    ;give LCD some time 
INC DPTR      ;increment address 
SJMP repeat2    ;jump to label repeat2

lcall delay
lcall delay
lcall delay

back:


MOV     A,#01h    ;clear LCD 
LCALL   comnwrt 
LCALL   lcddelay    ;give LCD some time 
  
MOV     A,#80H        ;cursor at line 1, position 0 
LCALL   comnwrt       ;call command subroutine 
LCALL   lcddelay      ;give LCD some time 
 
MOV     A, #'L'         ;display letter L 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'O'         ;display : symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
MOV     A, #'A'         ;display letter L 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'D'         ;display : symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
MOV     A, #'I'         ;display letter L 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'N'         ;display : symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
MOV     A, #'G'         ;display letter L 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'.'         ;display : symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
MOV     A, #'.'         ;display letter L 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'.'         ;display : symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time



light_check:    ;CHECKING LIGHT THRESHOLDS 
 
MOV A, LIGHT_LEVEL 
CJNE A, #4,KAI  
SETB LIGHT      ;turn on light 1 

SJMP KAI2
 KAI:
 CLR LIGHT

KAI2:
MOV A, MOIST_LEVEL
CJNE A, #1,KAI3
SETB PUMP

SJMP KAI4
 KAI3:
CLR PUMP
KAI4:

CLR heater


ACALL adcread   		 ;Read sensor data from ADC 
lJMP back    			 ;repeat ADC process 
 
       
 
lcddelay:  		;Delay subroutine  
	MOV R0, #90 
here1: 	MOV R1, #255 
here: 	DJNZ R1, here 
	DJNZ R0, here1 
	RET 

delay:  		;Delay subroutine  
	MOV R3, #250 
here2: 	MOV R4, #255 
here3: 	DJNZ R4, here3 
	DJNZ R3, here2 
	RET 

delay_5s:      ;5 second delay routine 
MOV R7, #100    ;REPEAT 100 TIMES (50ms*100= 5sec) 
sec_5: 
MOV TL0, #0FDh    ;load 4BFDh for 5ms delay 
MOV TH0, #4Bh 
SETB TR0      ;Start timer 0 
JNB TF0, $      ;Check for end of count 
CLR TR0      ;Stop timer 
CLR TF0      ;Clear timer 0 flag 
DJNZ R7, sec_5    ;Repeat till R7=0 
RET

comnwrt:               		
lcall ready		; Write when display not busy
	mov p0,a		; Command character in P1
	clr p2.5		; Command resister chosen
	clr p2.4		; Write enabled
	setb p2.7		; Strobe character to display
	clr p2.7
	ret 

ready:
	clr p2.7		; Display disabled
	mov p0,#0ffh		; Configure P1 for input
	clr p2.5		; Select command register
	setb p2.4		; Read enabled


wait:
	clr p2.7		; Strobe display
	setb p2.7		; Read busy status of display
	jb p0.7,wait		; Wait for not busy (BF = 0)
	clr p2.7		; End display strobe
	ret 

datawrt:			;write data to LCD 
	lcall ready		; Write when display ready
	mov P0,a		; Data character in P1
	setb p2.5		; Data resister chosen
	clr p2.4		; write enabled
	setb p2.7		; Strobe character to display
	clr P2.7
	ret


   
adcread:    			 ;Initializing ADC 

;light adc 
MOV ADCDATA, #0FFH  ; Data lines for input 
 
SETB EOC      ; Make EOC i/p 
CLR ALE      ; clearing ALE 
CLR START      ; Make start high 
CLR OE      ; Disable o/p 
  
clr ADD_A      ;A=0 
setb ADD_B      ;B=1  Select IN6 
ACALL delay  
SETB ALE      ;latching the address 
ACALL delay 
SETB START      ;start conversion pulse 
ACALL delay 
CLR ALE      ;ALE H-L transition 
CLR START      ;START H-L transition 
SETB OE      ;enable o/p 
ACALL delay     ; 
 
MOV L_BUFFER, ADCDATA  ;store adc data to buffer 
CLR OE   ;disable o/p 

;temp sensor
MOV ADCDATA, #0FFH  ;Data lines for input 
 
SETB EOC      ;Make EOC i/p 
CLR ALE      ;clearing ALE 
CLR START      ;Make start high 
CLR OE   ;Disable o/p 
  
setb ADD_A      ;A=1 
CLR ADD_B      ;B=0  ;Select IN5 
ACALL delay  
SETB ALE      ;latching the address 
ACALL delay 
SETB START      ;start conversion pulse 
ACALL delay 
CLR ALE      ;ALE H-L transition 
CLR START      ;START H-L transition 
SETB OE      ;enable o/p 
ACALL delay     ; 
 
MOV T_BUFFER, ADCDATA  ;store adc data to buffer 
CLR OE   ;disable o/p 


;moisture adc 
MOV ADCDATA, #0FFH  ; Data lines for input 
 
SETB EOC      ; Make EOC i/p 
CLR ALE      ; clearing ALE 
CLR START      ; Make start high 
CLR OE      ; Disable o/p 
  
setb ADD_A      ;A=1
setb ADD_B      ;B=1  Select IN7 
ACALL delay  
SETB ALE      ;latching the address 
ACALL delay 
SETB START      ;start conversion pulse 
ACALL delay 
CLR ALE      ;ALE H-L transition 
CLR START      ;START H-L transition 
SETB OE      ;enable o/p 
ACALL delay     ; 
 
MOV M_BUFFER, ADCDATA  ;store adc data to buffer 
CLR OE   ;disable o/p 










;LCD routine to display sensor and actuator data 
 
MOV  A, #01h      ;clear LCD 
ACALL comnwrt 
ACALL lcddelay    ;give LCD some time 
 
MOV  A,#80H         ;cursor at line 1, position 0 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay        ;give LCD some time









;DISPLAYING SENSOR 2: SOIL MOISTURE 
 
MOV     A, #'S'         ;display letter S 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time

mov sbuf,a
jnb ti,$
clr ti
 
MOV     A, #':'         ;display : symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay    ;give LCD some time 

mov sbuf,a
jnb ti,$
clr ti
  
MOV A, M_BUFFER    ;move sensor data from buffer to accumulator 
CJNE A, #67h, dry 
dry: 
JNC optimum 
MOV MOIST_LEVEL, #1  ;Store level in a buffer (for threshold check)  
MOV     A, #'D'       ;display D 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time

mov sbuf,a
jnb ti,$
clr ti
 
MOV     A, #'r'         ;display r 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
mov sbuf,a
jnb ti,$
clr ti
MOV     A, #'y'         ;display y 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
mov sbuf,a
jnb ti,$
clr ti
 
mov sbuf,#0dh
jnb ti,$
clr ti
  
LJMP moist_over 
optimum:     ;normal condition 
MOV A, M_BUFFER    ;move sensor data from buffer to accumulator 
CJNE A, #0a8h, disp_opt 
disp_opt: 
JNC slurry 
MOV MOIST_LEVEL, #2  ;Store level in a buffer (for threshold check) 
MOV     A, #'O'         ;display O 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'p'         ;display p 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
mov sbuf,a
jnb ti,$
clr ti
MOV     A, #'t'         ;display t 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'i'         ;display space 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 

MOV     A, #'m'         ;display space 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti
mov sbuf,#0dh
jnb ti,$
clr ti  
SJMP moist_over 
 
slurry: 
MOV MOIST_LEVEL, #3  ;Store level in a buffer (for threshold check 
MOV     A, #'E'         ;display E 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'x'         ;display x 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'c'         ;display c 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'e'         ;display e 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'s'         ;display s 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'s'         ;display s 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
mov sbuf,a
jnb ti,$
clr ti 
mov sbuf,#0dh
jnb ti,$
clr ti 
moist_over: 

;DISPLAYING TEMP


MOV     A, #' '       ;display letter T 
LCALL   datawrt       ;call display subroutine 
LCALL   lcddelay      ;give LCD some time
MOV     A, #' '       ;display letter T 
LCALL   datawrt       ;call display subroutine 
LCALL   lcddelay      ;give LCD some time
MOV     A, #'T'       ;display letter T 
LCALL   datawrt       ;call display subroutine 
LCALL   lcddelay      ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #':'       ;display : symbol 
LCALL   datawrt       ;call display subroutine 
LCALL   lcddelay      ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
       
MOV A, T_BUFFER    ;move sensor data from buffer to accumulator 
MOV DPTR, #temp_tens  ;address of ASCII code look up table (tens place) 
MOVC A, @A+DPTR    ;store corresponding ASCII code to Accumulator 
LCALL   datawrt     ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
  
MOV A, T_BUFFER    ;move sensor data from buffer to accumulator 
MOV DPTR, #temp_ones  ;address of ASCII code look up table (ones place) 
MOVC A, @A+DPTR    ;store corresponding ASCII code to Accumulator 
LCALL   datawrt    ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
  
MOV     A, #'.'         ;display . symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
  
MOV A, T_BUFFER    ;move sensor data from buffer to accumulator 
MOV DPTR, #temp_dec  ;address of ASCII code look up table (dec. place) 
MOVC A, @A+DPTR    ;store corresponding ASCII code to Accumulator 
LCALL   datawrt     ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
  
MOV     A, #0DFh        ;display degree symbol  
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'C'         ;display letter C 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti
mov sbuf,#0dh
jnb ti,$
clr ti  
          




;DISPLAYING LIGHT  

MOV A,#0C0H
LCALL comnwrt 
LCALL lcddelay
 
MOV     A, #'L'         ;display letter L 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
mov sbuf,a
jnb ti,$
clr ti
MOV     A, #':'         ;display : symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
mov sbuf,a
jnb ti,$
clr ti
 
MOV A, L_BUFFER    ;move sensor data from buffer to accumulator 
CJNE A, #25h, bright 
bright: 
JNC normal 
MOV LIGHT_LEVEL, #1  ;Store level in a buffer (for threshold check) 
MOV     A, #'B'         ;display S 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'r'         ;display u 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'i'         ;display n 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
mov sbuf,a
jnb ti,$
clr ti
MOV     A, #'g'         ;display n 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
mov sbuf,a
jnb ti,$
clr ti
MOV     A, #'h'         ;display n 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
mov sbuf,a
jnb ti,$
clr ti
MOV     A, #'t'         ;display n 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti
mov sbuf,#0dh
jnb ti,$
clr ti 
 
LJMP light_over 
 
normal: 
MOV A, L_BUFFER    ;move sensor data from buffer to accumulator 
CJNE A, #82h, disp_norm 
disp_norm: 
JNC dim 
MOV LIGHT_LEVEL, #2  ;Store level in a buffer (for threshold check) 
MOV     A, #'D'         ;display D 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'i'         ;display i 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
mov sbuf,a
jnb ti,$
clr ti
MOV     A, #'m'         ;display m 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
mov sbuf,a
jnb ti,$
clr ti
 mov sbuf,#0dh
jnb ti,$
clr ti
   
AJMP light_over 
 
dim: 
MOV A, L_BUFFER    ;move sensor data from buffer to accumulator 
CJNE A, #9Dh, disp_dim 
disp_dim: 
JNC dark 
MOV LIGHT_LEVEL, #3  ;Store level in a buffer (for threshold check) 
MOV     A, #'D'         ;display D 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay    ;give LCD some time 
mov sbuf,a
jnb ti,$
clr ti
MOV     A, #'a'         ;display a 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
mov sbuf,a
jnb ti,$
clr ti
MOV     A, #'r'         ;display r 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'k'         ;display k 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
 
mov sbuf,#0dh
jnb ti,$
clr ti  
SJMP light_over 
 
dark: 
MOV LIGHT_LEVEL, #4  ;Store level in a buffer (for threshold check) 
MOV     A, #'N'         ;display N 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'i'         ;display i 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'g'         ;display g 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'h'         ;display h 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
mov sbuf,a
jnb ti,$
clr ti 
MOV     A, #'t'         ;display t 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
mov sbuf,a
jnb ti,$
clr ti 
LCALL   lcddelay
mov sbuf,#0dh
jnb ti,$
clr ti 
light_over: 


lcall delay_5s

ret

org 600h 
 
init1: DB "WELCOME TO", 0 
init2: DB "    GREENHOUSE", 0  ; System initialisation message 

temp_tens: 
DB '0','0','0','0','0','0','0','0','0','0' 
DB 30h, 30h, 30h, 30h, 30h, 30h, 30h, 30h, 30h, 30h 
DB 30h, 30h, 30h, 30h, 30h, 30h, 31h, 31h, 31h, 31h 
DB 31h, 31h, 31h, 31h, 31h, 31h, 31h, 31h, 31h, 31h 
DB 31h, 31h, 32h, 32h, 32h, 32h, 32h, 32h, 32h, 32h 
DB 32h, 32h, 32h, 32h, 32h, 32h, 32h, 32h, 32h, 32h 
DB 32h, 32h, 32h, 32h, 32h, 32h, 32h, 32h, 33h, 33h 
DB 33h, 33h, 33h, 33h, 33h, 33h, 33h, 33h, 33h, 33h 
DB 33h, 33h, 33h, 33h, 33h, 33h, 33h, 33h, 33h, 33h 
DB 33h,'3', '3', 33h, 33h, 33h, 33h, 33h, 33h, 34h, 34h 
DB 35h, 35h, 35h, 35h, 35h, 35h, 35h, 35h, 35h, 35h 
DB 35h, 35h, 35h, 35h, 35h, 35h, 36h, 36h, 36h, 36h 
DB 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h, 36h 
 
temp_ones: 
DB '0', '0', '1', '1', '2', '2', '2', '3', '3', '3', '4' 
DB '4', '4', '5', '5', '5', '6', '6', '7', '7', '7' 
DB '8', '8', '8', '8', '9', '1', '1', '1', '2', '2' 
DB '3', '3', '4', '4', '5', '5', '5', '5', '5', '6' 
DB '6', '6', '7', '7', '7', '8', '8', '8', '9', '9' 
DB '9', '0', '0', '1', '1', '1', '2', '2', '2', '3' 
DB '3', '4', '4', '4', '5', '5', '6', '6', '6', '7' 
DB '7', '7', '8', '8', '9', '9', '9', '0', '0', '1' 
DB '1', '1', '2', '2', '2', '3', '3', '4', '4', '4' 
DB '5', '5', '5', '6', '6', '7', '7', '7', '8', '8' 
DB '9', '9', '9', '0', '0', '0', '1', '1', '2', '2' 
DB '2', '3', '3', '4', '4', '4', '5', '5', '6', '6' 
DB '6', '6', '7', '7', '0', '0', '0', '0', '0', '0' 
DB '0', '0', '0', '0', '0', '0', '0', '0', '0', '0' 
 
temp_dec: 
DB '0', '0','0','0','0','5','5','5','5','5','0'   ;10TH 
DB '0', '0','0','5','5','5','5','0','0','0'       ;20TH  
DB '0', '5','5','5','5','0','0','0','0','0'       ;30TH  
DB '5', '5','5','5','0','0','0','0','5','0'       ;40TH     
DB '0', '5','0','5','0','5','0','5','0','0'       ;50TH 
DB '5', '0','5','0','5','5','0','5','5','0'       ;60TH 
DB '5', '0','0','5','0','5','0','0','5','0'       ;70TH 
DB '5', '5','0','5','0','0','5','0','5','0'       ;80TH    
DB '0', '5','0','5','5','0','5','0','0','5'       ;90TH 
DB '0', '5','5','0','5','0','5','5','0','5'       ;100TH  
DB '0', '0','5','0','5','5','0','5','0','0'       ;110TH 
DB '5', '5','0','0','5','5','0','0','5','5'       ;120TH 
DB '0', '5','0','5','5','5','0','0','5','5'       ;130TH 
DB '0', '0','0','0','0','0','0','0','0','0'       ;140TH   



end

