 
LCDDATA  EQU  P0  	; P0.0-P0.7 are connected to LCD data pins D0-D7
 
org 00h 
mov sp,#40h
main:

MOV TMOD, #01h			 ;Timer 0 Mode 1, 16 bit timer(for generating 5 ;second delay for LCD) 


ACALL lcd_init   		;LCD initialisation 
back:
ACALL lcd1 	    		;Display welcome message 
LCALL delay_5s
ACALL data_display 		;call routine to display to LCD 
LCALL delay_5s
SJMP back      			;repeat ADC process 
 
lcd_init:   		 ;LCD initialisation 
MOV A, #38H   	  ;init. LCD 2 lines,5x7 matrix (CHANGE THIS!!!) 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #0CH        ;display on, cursor on 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #01        	;clear LCD 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #06H      	 ;shift cursor right 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
RET       
 
lcd1:			  ;Displaying initialisation message 
MOV A, #080H       ;cursor at line 1, position 0 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #01H       ;cursor at line 1, position 0 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay 
MOV DPTR, #init1    ;address of line 1 of initialisation message 
repeat1: 
CLR A 
MOVC A, @A+DPTR    ;moving the data to accumulator 
JZ line_2 
ACALL datawrt    ;call data display routine 
ACALL lcddelay    ;give LCD some time 
INC DPTR      ;increment address 
SJMP repeat1 
 
line_2: 
MOV A, #0C0h       ;cursor at line 2, position 0 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV DPTR, #init2    ;address of line 2 of initialisation message 
repeat2: 
CLR A 
MOVC A, @A+DPTR    ;moving the data to accumulator 
JZ exit_l2 
LCALL datawrt    ;call data display routine 
LCALL lcddelay    ;give LCD some time 
INC DPTR      ;increment address 
SJMP repeat2    ;jump to label repeat2   

exit_l2: 

LCALL lcddelay    ;give LCD some time 
RET 

delay:   ;Delay subroutine  
MOV R3, #250 
here1: 
MOV R4, #255 
here: 
DJNZ R4, here 
DJNZ R3, here1 
RET 

 
comnwrt:                ;send command to LCD 
lcall ready		; Write when display not busy
	mov p0,a		; Command character in P1
	clr p2.5		; Command resister chosen
	clr p2.4		; Write enabled
	setb p2.7		; Strobe character to display
	clr p2.7
	ret 

ready:
	clr p2.7		; Display disabled
	mov p0,#0ffh		; Configure P1 for input
	clr p2.5		; Select command register
	setb p2.4		; Read enabled


wait:
	clr p2.7		; Strobe display
	setb p2.7		; Read busy status of display
	jb p0.7,wait		; Wait for not busy (BF = 0)
	clr p2.7		; End display strobe
	ret


datawrt:              ;write data to LCD 
lcall ready		; Write when display ready
	mov P0,a		; Data character in P1
	setb p2.5		; Data resister chosen
	clr p2.4		; write enabled
	setb p2.7		; Strobe character to display
	clr P2.7
	ret

 
lcddelay:      ;Delay routine for LCD 
MOV     R0,#90   	;50 or higher for fast CPUs
HERE2:   MOV     R1,#255   	;R1=255
H1:   DJNZ    R1,H1   	;stay until R1 becomes 0
         DJNZ    R0,HERE2
         RET

delay_5s:      ;5 second delay routine 
MOV R7, #100    ;REPEAT 100 TIMES (50ms*100= 5sec) 
sec_5: 
MOV TL0, #0FDh    ;load 4BFDh for 5ms delay 
MOV TH0, #4Bh 
SETB TR0      ;Start timer 0 
JNB TF0, $      ;Check for end of count 
CLR TR0      ;Stop timer 
CLR TF0      ;Clear timer 0 flag 
DJNZ R7, sec_5    ;Repeat till R7=0 
RET
 
data_display:    ;LCD routine to display sensor and actuator data 
 
 

MOV  A, #01h    ;clear LCD 
LCALL comnwrt 
LCALL   lcddelay    ;give LCD some time 
  
MOV     A,#80H        ;cursor at line 1, position 0 
LCALL   comnwrt       ;call command subroutine 
LCALL   lcddelay      ;give LCD some time 
 
   
 
MOV     A, #'t'         ;display letter L 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'H'         ;display : symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'E'         ;display S 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #' '         ;display u 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'t'         ;display n 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'r'         ;display n 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'u'         ;display space 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'e'         ;display space 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 

MOV     A,#0C0H        ;cursor at line 2, position 0 
LCALL   comnwrt       ;call command subroutine 
LCALL   lcddelay      ;give LCD some time 

MOV     A, #'r'         ;display letter L 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'O'         ;display : symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'C'         ;display S 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'K'         ;display u 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'s'         ;display n 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'t'         ;display n 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'a'         ;display space 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'r'         ;display space 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 

RET 
        
 
org 600h 
 
init1: DB "harsh", 0 
init2: DB "pandya", 0  ; System initialisation message 

END
