;IN7 - LIGHT SENSOR 

 
RS   BIT  P2.5   		 ; P2.5 is connected to RS pin of LCD 
RW   BIT  P2.4  		 ; P2.6 is connected to R/W pin of LCD 
E   BIT  P2.7   		 ; P2.5 is connected to E pin of LCD 
 
LCDDATA  EQU  P0  	; P0.0-P0.7 are connected to LCD data pins D0-D7 
 
LIGHT_LEVEL   EQU  34h    ;Buffer to store light level 



 
 
OE  EQU  P3.2    		; Pin 9 Output Enable 
START EQU  P3.6    		; Pin 6 Start 
EOC  EQU  P3.3    		; Pin 7 EOC 
ADD_A EQU  P3.4    		; Pin 25 ADD A 
ADD_B EQU  P3.5    		; Pin 24 ADD B 
ALE  EQU  P3.7    		; Pin 22 ALE 
 
ADCDATA  EQU  P1    		; Data Lines 
 

L_BUFFER  EQU  33h    ;Light buffer (ADC o/p) 

org 00h 
  

mov sp,#40h
main: 
 
;Main Code 
  
MOV TMOD, #01h 		;Timer 0 Mode 1, 16 bit timer (for generating 5 
			;second delay for LCD) 

 ;LCD initialisation 
MOV A, #38H    	 ;init. LCD 2 lines,5x7 matrix (CHANGE THIS!!!) 
ACALL comnwrt       	;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #0EH        ;display on, cursor on 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #01        ;clear LCD 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 
MOV A, #06H       ;shift cursor right 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay      ;give LCD some time 

back: 


MOV     A,#01h    ;clear LCD 
LCALL   comnwrt 
LCALL   lcddelay    ;give LCD some time 
  
MOV     A,#80H        ;cursor at line 1, position 0 
LCALL   comnwrt       ;call command subroutine 
LCALL   lcddelay      ;give LCD some time 
 
MOV     A, #'L'         ;display letter L 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'O'         ;display : symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
MOV     A, #'A'         ;display letter L 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'D'         ;display : symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
MOV     A, #'I'         ;display letter L 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'N'         ;display : symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
MOV     A, #'G'         ;display letter L 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'.'         ;display : symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time
MOV     A, #'.'         ;display letter L 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'.'         ;display : symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time



ACALL adcread   		 ;Read sensor data from ADC 
lJMP back    			 ;repeat ADC process 
 
       
 
lcddelay:  		;Delay subroutine  
	MOV R0, #90 
here1: 	MOV R1, #255 
here: 	DJNZ R1, here 
	DJNZ R0, here1 
	RET 

delay:  		;Delay subroutine  
	MOV R3, #250 
here2: 	MOV R4, #255 
here3: 	DJNZ R4, here3 
	DJNZ R3, here2 
	RET 

delay_5s:      ;5 second delay routine 
MOV R7, #100    ;REPEAT 100 TIMES (50ms*100= 5sec) 
sec_5: 
MOV TL0, #0FDh    ;load 4BFDh for 5ms delay 
MOV TH0, #4Bh 
SETB TR0      ;Start timer 0 
JNB TF0, $      ;Check for end of count 
CLR TR0      ;Stop timer 
CLR TF0      ;Clear timer 0 flag 
DJNZ R7, sec_5    ;Repeat till R7=0 
RET

comnwrt:               		
lcall ready		; Write when display not busy
	mov p0,a		; Command character in P1
	clr p2.5		; Command resister chosen
	clr p2.4		; Write enabled
	setb p2.7		; Strobe character to display
	clr p2.7
	ret 

ready:
	clr p2.7		; Display disabled
	mov p0,#0ffh		; Configure P1 for input
	clr p2.5		; Select command register
	setb p2.4		; Read enabled


wait:
	clr p2.7		; Strobe display
	setb p2.7		; Read busy status of display
	jb p0.7,wait		; Wait for not busy (BF = 0)
	clr p2.7		; End display strobe
	ret 

datawrt:			;write data to LCD 
	lcall ready		; Write when display ready
	mov P0,a		; Data character in P1
	setb p2.5		; Data resister chosen
	clr p2.4		; write enabled
	setb p2.7		; Strobe character to display
	clr P2.7
	ret


   
adcread:    			 ;Initializing ADC 




;light adc 
MOV ADCDATA, #0FFH  ; Data lines for input 
 
SETB EOC      ; Make EOC i/p 
CLR ALE      ; clearing ALE 
CLR START      ; Make start high 
CLR OE      ; Disable o/p 
  
setb ADD_A      ;A=1
setb ADD_B      ;B=1  Select IN7 
ACALL delay  
SETB ALE      ;latching the address 
ACALL delay 
SETB START      ;start conversion pulse 
ACALL delay 
CLR ALE      ;ALE H-L transition 
CLR START      ;START H-L transition 
SETB OE      ;enable o/p 
ACALL delay     ; 
 
MOV L_BUFFER, ADCDATA  ;store adc data to buffer 
CLR OE   ;disable o/p 


;LCD routine to display sensor and actuator data 
 
MOV  A, #01h      ;clear LCD 
ACALL comnwrt 
ACALL lcddelay    ;give LCD some time 
 
MOV  A,#80H         ;cursor at line 1, position 0 
ACALL comnwrt       ;call command subroutine 
ACALL lcddelay        ;give LCD some time 
 
  
         
;DISPLAYING LIGHT  
 
MOV     A, #'L'         ;display letter L 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'-'         ;display : symbol 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
 
MOV A, L_BUFFER    ;move sensor data from buffer to accumulator 
CJNE A, #25h, bright 
bright: 
JNC normal 
MOV LIGHT_LEVEL, #1  ;Store level in a buffer (for threshold check) 
MOV     A, #'O'         ;display S 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'p'         ;display u 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'t'         ;display n 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'.'         ;display n 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #' '         ;display space 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
LJMP light_over 
 
normal: 
MOV A, L_BUFFER    ;move sensor data from buffer to accumulator 
CJNE A, #82h, disp_norm 
disp_norm: 
JNC dim 
MOV LIGHT_LEVEL, #2  ;Store level in a buffer (for threshold check) 
MOV     A, #'D'         ;display D 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'i'         ;display i 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'m'         ;display m 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #' '         ;display space 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #' '         ;display space 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
   
SJMP light_over 
 
dim: 
MOV A, L_BUFFER    ;move sensor data from buffer to accumulator 
CJNE A, #9Dh, disp_dim 
disp_dim: 
JNC dark 
MOV LIGHT_LEVEL, #3  ;Store level in a buffer (for threshold check) 
MOV     A, #'D'         ;display D 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay    ;give LCD some time 
MOV     A, #'a'         ;display a 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'r'         ;display r 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'k'         ;display k 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #' '         ;display space 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
  
SJMP light_over 
 
dark: 
MOV LIGHT_LEVEL, #4  ;Store level in a buffer (for threshold check) 
MOV     A, #'N'         ;display N 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'i'         ;display i 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'g'         ;display g 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'h'         ;display h 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
MOV     A, #'t'         ;display t 
LCALL   datawrt         ;call display subroutine 
LCALL   lcddelay        ;give LCD some time 
  
light_over: 
lcall delay_5s
RET 
        
 

END






